#include <stdlib.h>
#include <string.h>
#include <stdio.h>
#include <errno.h>

#include "ProcessCIFLoop.h"


int main( int argc, char **argv )
{
    FILE *fp;
    char *ptr = NULL;
    int i;
    char *cat = "_geom_bond";
    char line[CIF_LINE_LEN];
    struct cif_loop *loop_ptr;
    struct cif_loop_header *head, 
                           *current;

    struct cif_loop_row    *top_row,
                           *current_row;

    if( argc != 2 ) {
      fprintf( stderr, "Usage: %s <cif_file_name>. Exiting.\n", 
               argv[0] );
      exit( EXIT_SUCCESS );
    }

    fp = fopen( argv[argc-1], "r" );
    if( !fp ) {
        perror( argv[argc-1] );
        exit( EXIT_FAILURE );
    }

    while( NULL != fgets(line, CIF_LINE_LEN, fp) ) {
        if( NULL != (ptr = strchr( line, '\n')) ) *ptr = '\0';
        if( NULL != strstr( line, "loop_" ) )
             loop_ptr = ProcessCIFLoop( fp, cat );
    }   

/* set the pointers to the top of the list. */
    head = loop_ptr->head_anchor.next;
    top_row = loop_ptr->row_anchor.next;

    printf( "Print out loop_ data names:\n" );
    for( current = head; NULL != current->next; current = current->next )
         printf( "%s\n", current->field_name );

    printf( "\nPrint out loop_ data values:\n" ); 
    for( current_row = top_row; NULL != current_row->next; 
         current_row = current_row->next ) {
         for( i = 0; i < loop_ptr->n_fields; i++ )
            printf( "%s ", current_row->field_ptr[i] );
         printf( "\n" );
    }
   
    FreeCIFLoop( loop_ptr );
    exit( EXIT_SUCCESS );
}
